@echo off
setlocal ENABLEDELAYEDEXPANSION

set DriveLetter=%1
set ExpectedVL=SQLServer2008
set ExpectedDirs=2097
set ExpectedFiles=2424
set Dirs=
set Files=
set MisCount=
set LocFile=File(s)
set LocDir=Dir(s)
set CD=SQL Server2008 Enterprise Edition

if "%1"=="" goto usage

REM Verify that fciv.exe exists in the path
fciv -? >NUL
if NOT [%errorlevel%]==[0] goto usage

REM Verify there is a valid CD in the drive
vol %1 > NUL
if NOT [%errorlevel%]==[0] goto usage

REM Check Volume ID
for /f "usebackq tokens=6 delims= " %%V in (`vol %1 `) do set VolumeID=%%V&echo.
if NOT %VolumeID%==%ExpectedVL% (
   echo The volume label of the CD in drive %1 is %VolumeID%
   echo This integrity check can identify only original CDs with Volume Label: %ExpectedVL%
   echo Please insert the CD with volume label %ExpectedVL%. Then try again.
   echo.
goto end
)

@REM *** Count directories and Files
for /F "usebackq tokens=1 delims= " %%J in (`dir /s /A:D %DriveLetter% ^| findstr /c:"%LocDir%"`) do (set Dirs=%%J) 
for /F "usebackq tokens=1 delims= " %%J in (`dir /s /A-D %DriveLetter% ^| findstr /c:"%LocFile%"`) do (set Files=%%J) 

if NOT [%Dirs%]==[%ExpectedDirs%]   Set MisCount=Yes&echo *** The CD in %1 contains %Dirs%   directories instead of %ExpectedDirs% ***
if NOT [%Files%]==[%ExpectedFiles%] Set MisCount=Yes&echo *** The CD in %1 contains %Files%  files instead of %ExpectedFiles% ***
if [%MisCount%]==[Yes] goto end

echo          The verification process may take several minutes...
echo          The files on the CD are being scanned to validate their integrity
echo          ......
echo.

@REM *** Run the integrity check
fciv -v %1\ -r -sha1 -bp %1\ -xml %ExpectedVL%.xml > integritycheck.log
findstr /c:"All files verified successfully" integritycheck.log
if NOT [%errorlevel%]==[0] (
   echo The integrity check could not validate all the files on the CD
   echo The integrity check log file is saved in the current directory...
   pause
   notepad integritycheck.log
   echo.
   goto end
) else (
   echo.
   echo The CD in drive %1 is an authentic %CD%
   echo.
   del integritycheck.log
)


goto end

:usage
echo Usage: 
echo        %~nx0 x:
echo        x:  CD-ROM drive containing SQL Server2008 Enterprise Edition (Volume Label: %ExpectedVL%)
echo        Fciv.exe must be in the current directory or in the path.
echo        You can download Fciv.exe from http://support.microsoft.com/default.aspx?scid=kb;en-us;841290
echo.

:end
endlocal